static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "rectpairC.h"
#include "rectpair_memo.h"
#define RECTPAIR_MAIN
#include <time.h>

static int 	chk_, chk_rc;
#define CHKA(x,y,z) (chk_+=chk_rc=((x)<=(y)&&(y)< (z))?0:\
	(chk_ab(0,(long)(x),(long)(y),(long)(z),__file,__LINE__,"x","y","z")),chk_rc)
#define CHKB(x,y,z) (chk_+=chk_rc=((x)<=(y)&&(y)<=(z))?0:\
	(chk_ab(1,(long)(x),(long)(y),(long)(z),__file,__LINE__,"x","y","z")),chk_rc)

#define Dprintf	printf
#define dbgf 0  //fobNpBƂŏ
FILE *fpw;      //fobNp

static int chk_ab  (int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz ) {
	if( chk_ <= 200 )
		Dprintf("*** CHK%c error <== %8s(%d) %s(%ld) %s(%ld) %s(%ld)\n" ,
			t?'B':'A', file, line, sx, lx, sy, ly, sz, lz ) ; fflush(stdout);
	return(1);
}
//fobNpB
void dump_rect(Rect *rect, int n_rect)
{
	int k;
	fprintf(fpw, "	x1	x2	y1	y2\n");
	for( k = 0; k < n_rect; ++k ) {
		fprintf(fpw, "%d)	%d	%d	%d	%d"
			, k, rect[k].x1, rect[k].x2, rect[k].y1, rect[k].y2);	
#if defined (RECT_GROUP)
		fprintf(fpw, "	%d", rect[k].group);
#endif //RECT_GROUP
#if defined (RECT_COUNT)
		fprintf(fpw, "	%d", rect[k].count);
#endif //RECT_COUNT
		fprintf(fpw, "\n");
	}
	return;
}
#if defined (RECT_GROUP)
int chkGroup(Rect *rect, int n_rect)
{
	int k, rc, i, x1, x2, y1, y2, arect, group, n_list, selfFlag = 0, cross;
	int list[100000];
	XSET_CLASS xs;

	for( k = 0; k < n_rect; ++k ) {
		xs.clear();
		xs.push(k);
		//k Ԗڂ̒`ƏdȂ钷` list[] ɐݒ肷
		n_list = adjacent_rect_list(list, k, selfFlag);   //CHKB(0, rc, 0);
		group = rect[k].group;
		//dȂ钷`݂ȂȂ΁AO[vԍ͂Ô͂
		if( (n_list == 0 && selfFlag == 0) || (n_list == 1 && selfFlag == 1) ) { CHKB(0, group, 0);
		} else                          CHKB(1, 1, group);
		rc = 0;
		for( i = selfFlag; i < n_list; ++i ) {
			arect = list[i];
			if( xs.exist(arect) )       CHKA(i, arect, -1);
			xs.push(arect);
		}
		//k Ԗڂ̒`ƁAo^ꂽ`dȂ邩AȊO̒`{ɏdȂȂ𒲂ׂ
		x1 = rect[k].x1; x2 = rect[k].x2; y1 = rect[k].y1; y2 = rect[k].y2;
		for( i = 0; i < n_rect; ++i ) {
			cross = ! (rect[i].x1 > x2 || rect[i].x2 < x1 || rect[i].y1 > y2 || rect[i].y2 < y1);
			if( xs.exist(i) ) {         CHKB(group, rect[i].group, group);
				CHKB(1, cross, 1);
			} else {
				CHKB(0, cross, 0);
			}
		}
	}
	return rc;
}
#endif //RECT_GROUP

static unsigned long   X[3] = { 0x5555, 0x5555, 0x5555 }; /* l */
static unsigned short  A[3] = { 0x0005, 0xDEEC, 0xE66D }; /* 搔l */
static unsigned short  C[3] = { 0x0000, 0x0000, 0x000B }; /* l */
long lrand48() /* NT031022add */
{
//    double  drc;
    unsigned long 	lrc;
	register unsigned long	z0, z1, z2, *xx = X, smask = 0xffff; /*, smask = 0x7fffffff;*/
	register unsigned short  *aa = A;
    do {
    	z2  = xx[2]*aa[2] + C[2];
		z1  = (z2 >> 16) + xx[2]*aa[1] + xx[1]*aa[2];
	    z0  = (z1 >> 16) + xx[0]*aa[2] + xx[1]*aa[1] + xx[2]*aa[0];
		xx[2] = z2 & smask;
		xx[1] = z1 & smask;
		xx[0] = z0 & smask;
        lrc = (xx[1] << 16) + xx[2];
    } while( lrc == 0xFFFFFFFF );
    return( lrc & 0x7FFFFFFF );
}
int genRect(Rect *rect, int n_rect, int randnum )
{
	int		k, rc = 0, x1, y1, l1, l2;
	Rect wrect;

	//Wl߂
	for( k = 0; k < n_rect; ++k ) 	{
			x1 = lrand48() ; y1 = lrand48();
			l1 = lrand48() % randnum;  l2 = lrand48() % randnum;
//			x1 = rand() ; y1 = rand();
//			l1 = rand() % randnum;  l2 = rand() % randnum;
			if( 0x7FFFFFFF - l1 < x1 ) l1 = 0x7FFFFFFF - x1; 
			if( 0x7FFFFFFF - l2 < y1 ) l2 = 0x7FFFFFFF - y1; 
//		l1 = l2 = 1;
			wrect.x1 = x1; 	wrect.x2 = x1 + l1;	    CHKB(wrect.x1, wrect.x2, wrect.x2);
			wrect.y1 = y1;	wrect.y2 = y1 + l2;		CHKB(wrect.y1, wrect.y2, wrect.y2);
//			wrect.group = 0;
		rect[k] = wrect;
	}
	return 0;
}
int seino_test(void *ptr)
{
	int numtb[]  = {1, 2, 3, 10, 32, 100, 316, 1000, 3162, 10000, 31623, 100000 };
	int loop[]   = {100, 100, 100, 100, 100, 100, 100, 100, 30, 10, 3, 1 };
	int randtb[] = {1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000 };
	int i, k, n_numtb, rc = -1, num, n_grp, randnum, cnt;
	time_t now1, now2; // i 0:VXe !=0:time()̌ʂw
	Rect *rect;

	n_numtb = 12;
//	n_numtb = 9;
#if ! defined(_DEBUG)
	if(dbgf == 0) n_numtb = 12;
#endif

    if( (rect = (Rect *)malloc (sizeof(Rect)*100000)) == 0) goto                      quit;
	fprintf(fpw, "genRect:  n_rect   n_grp   cpu   n_ovl\n"); fflush(fpw);
	Dprintf(     "genRect:  n_rect   n_grp   cpu   n_ovl\n"); fflush(stdout);
	for( i = 0; i< n_numtb; ++i ) {
		num = numtb[i];
		//Wl߂
		randnum = randtb[i];
		randnum = 0x7FFFFFFF / num * 20;
//		randnum = 0x7FFFFFFF / num;
		n_grp = genRect(rect, num, randnum);
		now1 = clock();
		for( k = 0; k < loop[i]; ++k ) {
			if( (n_grp = rectPairs (ptr, rect, num, 0, 0)) < 0 ) { rc = -1; goto              quit; }
		}
		now2 = clock();
		for( cnt = k = 0; k < num; ++k ) {
			cnt += rect[k].count;
		}
//		fprintf(fpw, "genRect: (%6d) (%5d) (%6.2f) (%5d)\n", num, n_grp, (double)(now2 - now1) / loop[i], n_ovlp(ptr) ); fflush(fpw);
//		Dprintf(     "genRect: (%6d) (%5d) (%6.2f) (%5d)\n", num, n_grp, (double)(now2 - now1) / loop[i], n_ovlp(ptr) ); fflush(stdout);
		fprintf(fpw, "genRect: (%6d) (%5d) (%6.2f) (%5d)\n", num, n_grp, (double)(now2 - now1) / loop[i], cnt ); fflush(fpw);
		Dprintf(     "genRect: (%6d) (%5d) (%6.2f) (%5d)\n", num, n_grp, (double)(now2 - now1) / loop[i], cnt ); fflush(stdout);
		if( dbgf>1 ) dump_rect(rect, num);
#if defined (RECT_GROUP)
		if( dbgf ) chkGroup(rect, num);
#endif //RECT_GROUP
	}
	free(rect);
quit:
	return rc;
}
int
main(int argc, char *argv[])
{
	int c;
	void *ptr;
	fpw = fopen("sscdbgf.txt", "w");
	ptr = rect_pair_init ();
	seino_test(ptr);
	rect_pair_free(ptr);
	fclose(fpw);
	Dprintf("test end\n");
	scanf("%c", &c);
	return 0;
}