/* 
 * FILE     : rectpair.h
 * FUNCTION : dȂ`̍O[sO
 * AUTHOR   : SSC N.Tsuchiya 2011.12.11
 */
#if ! defined(rectpair_h)
#define rectpair_h

#if defined (__cplusplus)
extern "C" {
#endif
#include"rect.h"

typedef struct iheap {
	int 	(*comp)(int a,int b);      /* r֐       */	
	int 	num, max;          /* f[^AMAXl  */
	int 	*data;             /* f[^           */
}IHEAP;

#define Empty  0
#define isEmpty(p) ((p)<=Empty)
#define     E 0          /* oXx E: EB*/
#define     L -1         /* oXx L: ɌXĂB*/
#define     R 1          /* oXx R: EɌXĂB*/

typedef struct  {
	struct BPSTpair {
		int		n;           //ߓ_ԍ([Uw)
		int		x;           //T؂\
		int		y;           //q[v\
		int		emptyNext;   //󃊃NB擪topEmptyPairB-1:gp
	} ;
	struct BPSTnode {
		int 	p;       //q[v\B(leaf node)(McCreght validP=.F.)̏ꍇ     pair[]
		int 	q;       //T؂\                                     pair[]
		int 	validP;  //(McCreght only) T:t.p͗L(łȂ)
		char	duplQ;   //(McCreght only) T:t.q͑c悁a.pɐݒς F:t.qƓyA͏ʂ̂ɂ݂͑Ȃ
		int		oya;     // -2:폜   node[]
		int		left;    // -2:폜   node[]
		int		right;   //           node[]
		int    hight;             // ؂̍B[̍PDmFpA߂
	} ;
	struct ExtractedPair {
		int 	qq;
		char	duplAsP;
	} ;
	struct BPSTnode *node;  //node[0]͎gȂ
	struct BPSTpair *pair;  //pair[0]͎gȂ
	int		heapType;        //0:傫D 1:D add NT110404
	int		root;            //                                        node[]
	int		num_node;        //gpvfB_~[Ƌ󂫗vf܂
	int		num_pair;        //gpyAB_~[Ƌ󂫗vf܂
	int		n_node;          //폜ς݂gp node[]
	int		n_pair;          //폜ς݂gp pair[]B
	int		max_node;        //mۍςݗeʁBvf
	int		max_pair;        //mۍςݗeʁByA
	int		topEmptyNode;    //                                        node[]
	int		topEmptyPair;    //                                        pair[]
	int		last_node;    //ŌɕԂm[hԍB-1:TI            node[]or-1
	int		lastIsP;      //(McCreght only) 
} LSEG;
typedef LSEG PSTree;

typedef struct  {      //W̃}[W
	int		parent;    //smg[]
	int		weight;    //؂̏d
} MERGE;
#if defined (RECT_PAIR)
typedef struct  {      //`̏dȂ̃yA
	int		next;      //̑B擪 rect2[].topOvlpe   ovlpe[]or-1
	int		n2;        //dȂ葊̒`       rect2[] smg[]
} OVLPEdge;
#endif //RECT_PAIR
typedef struct  {      //`̕t
	int		topOvlpe;      //dȂ擪̒`        ovlpe[]or-1
} RECT2;

typedef struct  {      //f[^̊Ǘ
	int		work;      //= n_rect         work[]
	int		smg;       //= n_rect         smg[]
	int		ovlpe;     //őn_rect**2      ovlpe[]
	int		rect2;     //= n_rect         rect2[]
} number_st;

typedef struct {
	Rect	*rect;    //[n_rect] `z
	int		n_rect;    //=ssize
	int		distance;
	int		pairFlg;   //1:pair[]ȂB
	int     *work;     //[pn.work] \[gp[N
	number_st  pn, px; // z̎gpf[^Aeʂ̊Ǘ
	IHEAP	ihp;       // W̋`̏ӂl̃q[v
	LSEG	ls;        // W
	MERGE	*smg;      //[pn.smg] W̃}[W
	RECT2	*rect2;
#if defined (RECT_PAIR)
	OVLPEdge *ovlpe;
#endif //RECT_PAIR
} psgloval_st;

void *rect_pair_init ();
int rectPairs (void *ptr, Rect *rect, int ssize, int distance, int pairFlg);
void rect_pair_free (void *ptr);

#if defined (RECT_PAIR)
int adjacent_rect_list(void *ptr, int *list, int arect, int selfFlag);
int n_ovlp(void *ptr);
#endif //RECT_PAIR

#if defined (__cplusplus)
}
#endif

#endif //! defined(rectpair_h)
